(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ng-gx-split-text', ['exports', '@angular/core', 'rxjs', '@angular/common'], factory) :
    (global = global || self, factory(global['ng-gx-split-text'] = {}, global.ng.core, global.rxjs, global.ng.common));
}(this, function (exports, core, rxjs, common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var objectProto = Object.prototype;
    /** @type {?} */
    var hasOwnProperty = objectProto.hasOwnProperty;
    /**
     * @param {?} object
     * @param {...?} sources
     * @return {?}
     */
    function defaults(object) {
        var sources = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            sources[_i - 1] = arguments[_i];
        }
        object = Object(object);
        sources.forEach((/**
         * @param {?} source
         * @return {?}
         */
        function (source) {
            if (source != null) {
                source = Object(source);
                for (var key in source) {
                    if (source.hasOwnProperty(key)) {
                        /** @type {?} */
                        var value = object[key];
                        if (value === undefined ||
                            (eq(value, objectProto[key]) && !hasOwnProperty.call(object, key))) {
                            object[key] = source[key];
                        }
                    }
                }
            }
        }));
        return object;
    }
    /**
     * @param {?} value
     * @param {?} other
     * @return {?}
     */
    function eq(value, other) {
        return value === other || (value !== value && other !== other);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var defaultOptions = {
        defer: false,
        onlyWords: false,
        mask: false,
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SplitNodes = /** @class */ (function () {
        function SplitNodes(textContent, el, options) {
            this.textContent = textContent;
            this.el = el;
            this.options = options;
            this.words = [];
            this.chars = [];
            this.lineWords = [];
            this.lineChars = [];
            this.wordsArray = [];
            this.nodes = [];
            this.nodeTypes = {
                ELEMENT_NODE: 1,
                ATTRIBUTE_NODE: 2,
                TEXT_NODE: 3,
                CDATA_SECTION_NODE: 4,
                ENTITY_REFERENCE_NODE: 5,
                ENTITY_NODE: 6,
                PROCESSING_INSTRUCTION_NODE: 7,
                COMMENT_NODE: 8,
                DOCUMENT_NODE: 9,
                DOCUMENT_TYPE_NODE: 10,
                DOCUMENT_FRAGMENT_NODE: 11,
                NOTATION_NODE: 12
            };
        }
        /**
         * @return {?}
         */
        SplitNodes.prototype.initSplitNodes = /**
         * @return {?}
         */
        function () {
            this.splitNodes(this.el);
            this.initNewNodes();
            this.setLines();
            this.updateOnResize();
        };
        /**
         * @param {?} el
         * @return {?}
         */
        SplitNodes.prototype.splitNodes = /**
         * @param {?} el
         * @return {?}
         */
        function (el) {
            var _this = this;
            var _loop_1 = function (i) {
                /** @type {?} */
                var node = el.childNodes[i];
                /** @type {?} */
                var tag = [this_1.nodeTypes.ELEMENT_NODE, this_1.nodeTypes.DOCUMENT_NODE, this_1.nodeTypes.DOCUMENT_FRAGMENT_NODE].indexOf(node.nodeType) !== -1;
                /** @type {?} */
                var text = [this_1.nodeTypes.TEXT_NODE, this_1.nodeTypes.CDATA_SECTION_NODE].indexOf(node.nodeType) !== -1;
                if (tag) {
                    this_1.splitNodes(node);
                }
                else if (text) {
                    /** @type {?} */
                    var words = this_1.splitNodesIntoWords(node);
                    /** @type {?} */
                    var wordsArray_1 = [];
                    words.forEach((/**
                     * @param {?} chars
                     * @return {?}
                     */
                    function (chars) {
                        /** @type {?} */
                        var wordSpan = document.createElement('span');
                        wordSpan.classList.add('split-text-word');
                        wordSpan.style.display = 'inline-block';
                        wordSpan.style.textIndent = '0';
                        if (_this.options.onlyWords) {
                            wordSpan.innerHTML = chars.join('');
                        }
                        else {
                            chars.forEach((/**
                             * @param {?} char
                             * @return {?}
                             */
                            function (char) {
                                /** @type {?} */
                                var charSpan = document.createElement('span');
                                charSpan.classList.add('split-text-char');
                                charSpan.style.display = 'inherit';
                                charSpan.style.textIndent = '0';
                                charSpan.innerHTML = char;
                                wordSpan.appendChild(charSpan);
                                _this.chars.push(charSpan);
                            }));
                        }
                        wordsArray_1.push(wordSpan);
                        _this.words.push(wordSpan);
                    }));
                    this_1.wordsArray.push(wordsArray_1);
                    this_1.nodes.push(node);
                }
            };
            var this_1 = this;
            for (var i = 0; i < el.childNodes.length; i++) {
                _loop_1(i);
            }
        };
        /**
         * @return {?}
         */
        SplitNodes.prototype.initNewNodes = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.nodes.forEach((/**
             * @param {?} node
             * @param {?} index
             * @return {?}
             */
            function (node, index) {
                _this.wordsArray[index].forEach((/**
                 * @param {?} word
                 * @param {?} idx
                 * @return {?}
                 */
                function (word, idx) {
                    /** @type {?} */
                    var maskSpan;
                    if (_this.options.mask) {
                        maskSpan = document.createElement('span');
                        maskSpan.classList.add('split-text-mask');
                        maskSpan.style.display = 'inline-block';
                        maskSpan.style.overflow = 'hidden';
                        maskSpan.style.textIndent = '0';
                        maskSpan.style.verticalAlign = 'top';
                        maskSpan.appendChild(word);
                        node.parentNode.insertBefore(maskSpan, node);
                    }
                    else {
                        node.parentNode.insertBefore(word, node);
                    }
                    /** @type {?} */
                    var spaceSpan = document.createElement('span');
                    spaceSpan.classList.add('split-text-space');
                    spaceSpan.style.display = 'inline';
                    spaceSpan.innerHTML = ' ';
                    if (_this.options.mask) {
                        node.parentNode.insertBefore(spaceSpan, maskSpan.nextSibling);
                    }
                    else {
                        node.parentNode.insertBefore(spaceSpan, word.nextSibling);
                    }
                    if (idx === _this.wordsArray[index].length - 1) {
                        node.remove();
                    }
                }));
            }));
        };
        /**
         * @param {?} word
         * @return {?}
         */
        SplitNodes.prototype.splitNodesIntoWords = /**
         * @param {?} word
         * @return {?}
         */
        function (word) {
            /** @type {?} */
            var words = word.textContent.split(' ');
            if (words[0] === '') {
                words.splice(0, 1);
            }
            if (words[words.length - 1] === '') {
                words.splice(words.length - 1, 1);
            }
            return words.map((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return item.split(''); }));
        };
        /**
         * @param {?} elements
         * @return {?}
         */
        SplitNodes.prototype.getLines = /**
         * @param {?} elements
         * @return {?}
         */
        function (elements) {
            /** @type {?} */
            var lineElements = [];
            /** @type {?} */
            var line = [];
            /** @type {?} */
            var lineIndex = 0;
            elements.forEach((/**
             * @param {?} el
             * @param {?} index
             * @return {?}
             */
            function (el, index) {
                /** @type {?} */
                var firstElTop = elements[lineIndex].getBoundingClientRect().top;
                /** @type {?} */
                var lastElIndex = elements.length - 1;
                if (el.getBoundingClientRect().top === firstElTop) {
                    line.push(el);
                    if (index === lastElIndex) {
                        lineElements.push(line);
                    }
                }
                else {
                    lineElements.push(line);
                    lineIndex = index;
                    line = [];
                    line.push(el);
                }
            }));
            return lineElements;
        };
        /**
         * @return {?}
         */
        SplitNodes.prototype.updateOnResize = /**
         * @return {?}
         */
        function () {
            var _this = this;
            rxjs.fromEvent(window, 'resize')
                .subscribe((/**
             * @return {?}
             */
            function () {
                _this.setLines();
            }));
        };
        /**
         * @return {?}
         */
        SplitNodes.prototype.setLines = /**
         * @return {?}
         */
        function () {
            this.lineWords = this.getLines(this.words);
            if (!this.options.onlyWords) {
                this.lineChars = this.getLines(this.chars);
            }
        };
        return SplitNodes;
    }());
    if (false) {
        /** @type {?} */
        SplitNodes.prototype.words;
        /** @type {?} */
        SplitNodes.prototype.chars;
        /** @type {?} */
        SplitNodes.prototype.lineWords;
        /** @type {?} */
        SplitNodes.prototype.lineChars;
        /** @type {?} */
        SplitNodes.prototype.wordsArray;
        /** @type {?} */
        SplitNodes.prototype.nodes;
        /** @type {?} */
        SplitNodes.prototype.nodeTypes;
        /**
         * @type {?}
         * @private
         */
        SplitNodes.prototype.textContent;
        /**
         * @type {?}
         * @private
         */
        SplitNodes.prototype.el;
        /**
         * @type {?}
         * @private
         */
        SplitNodes.prototype.options;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgGxSplitTextDirective = /** @class */ (function () {
        function NgGxSplitTextDirective(el) {
            this.el = el;
            this.init = false;
        }
        /**
         * @return {?}
         */
        NgGxSplitTextDirective.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.setCurrentOptions();
            this.initSplitNodes();
        };
        /**
         * @return {?}
         */
        NgGxSplitTextDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            if (!this.currentOptions.defer) {
                this.initSplit();
            }
        };
        /**
         * @return {?}
         */
        NgGxSplitTextDirective.prototype.initSplit = /**
         * @return {?}
         */
        function () {
            if (this.init) {
                console.warn('Warning! Text is already initialized');
                return;
            }
            this.init = true;
            this.saveSrcText();
            this.splitNodes.initSplitNodes();
        };
        /**
         * @private
         * @return {?}
         */
        NgGxSplitTextDirective.prototype.saveSrcText = /**
         * @private
         * @return {?}
         */
        function () {
            this.srcTextContent = this.el.nativeElement.innerHTML;
        };
        Object.defineProperty(NgGxSplitTextDirective.prototype, "words", {
            get: /**
             * @return {?}
             */
            function () {
                return this.splitNodes.words;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgGxSplitTextDirective.prototype, "lineWords", {
            get: /**
             * @return {?}
             */
            function () {
                return this.splitNodes.lineWords;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgGxSplitTextDirective.prototype, "chars", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.options.onlyWords) {
                    console.warn('Warning! You chose only words.');
                    return;
                }
                return this.splitNodes.chars;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgGxSplitTextDirective.prototype, "lineChars", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.options.onlyWords) {
                    console.warn('Warning! You chose only words.');
                    return;
                }
                return this.splitNodes.lineChars;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgGxSplitTextDirective.prototype, "nativeElement", {
            get: /**
             * @return {?}
             */
            function () {
                return this.el.nativeElement;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgGxSplitTextDirective.prototype, "srcText", {
            get: /**
             * @return {?}
             */
            function () {
                return this.srcTextContent;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NgGxSplitTextDirective.prototype, "isInit", {
            get: /**
             * @return {?}
             */
            function () {
                return this.init;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NgGxSplitTextDirective.prototype.resetSplit = /**
         * @return {?}
         */
        function () {
            this.nativeElement.innerHTML = this.srcText;
        };
        /**
         * @private
         * @return {?}
         */
        NgGxSplitTextDirective.prototype.setCurrentOptions = /**
         * @private
         * @return {?}
         */
        function () {
            this.currentOptions = defaults(this.options, defaultOptions);
        };
        /**
         * @private
         * @return {?}
         */
        NgGxSplitTextDirective.prototype.initSplitNodes = /**
         * @private
         * @return {?}
         */
        function () {
            this.splitNodes = new SplitNodes(this.el.nativeElement.textContent, this.el.nativeElement, this.currentOptions);
        };
        NgGxSplitTextDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[ngGxSplitText], ngGxSplitText'
                    },] }
        ];
        /** @nocollapse */
        NgGxSplitTextDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        NgGxSplitTextDirective.propDecorators = {
            options: [{ type: core.Input, args: ['ngGxSplitText',] }]
        };
        return NgGxSplitTextDirective;
    }());
    if (false) {
        /** @type {?} */
        NgGxSplitTextDirective.prototype.options;
        /**
         * @type {?}
         * @private
         */
        NgGxSplitTextDirective.prototype.srcTextContent;
        /**
         * @type {?}
         * @private
         */
        NgGxSplitTextDirective.prototype.init;
        /**
         * @type {?}
         * @private
         */
        NgGxSplitTextDirective.prototype.currentOptions;
        /**
         * @type {?}
         * @private
         */
        NgGxSplitTextDirective.prototype.splitNodes;
        /**
         * @type {?}
         * @private
         */
        NgGxSplitTextDirective.prototype.el;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function Options() { }
    if (false) {
        /** @type {?|undefined} */
        Options.prototype.defer;
        /** @type {?|undefined} */
        Options.prototype.onlyWords;
        /** @type {?|undefined} */
        Options.prototype.mask;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgGxSplitTextModule = /** @class */ (function () {
        function NgGxSplitTextModule() {
        }
        NgGxSplitTextModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            NgGxSplitTextDirective,
                        ],
                        imports: [
                            common.CommonModule,
                        ],
                        exports: [
                            NgGxSplitTextDirective,
                        ],
                    },] }
        ];
        return NgGxSplitTextModule;
    }());

    exports.NgGxSplitTextDirective = NgGxSplitTextDirective;
    exports.NgGxSplitTextModule = NgGxSplitTextModule;
    exports.defaultOptions = defaultOptions;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ng-gx-split-text.umd.js.map
